function init()
	RegisterTool("killstreak50", "Killstreak (50)", "MOD/vox/killstreak50.vox", 1)
	SetBool("game.tool.killstreak50.enabled", true)
	SetFloat("game.tool.killstreak50.ammo", 101)
	
	slappower = GetFloat("savegame.mod.slappower")
	if slappower == 0 then slappower = 1500 end
	swingTimer = 0.1

	line = {}
	line.active = false
	damage = 0.3
	hitsound = LoadSound("MOD/snd/hitsound.ogg")
	local r,g,b = GetPostProcessingProperty("colorbalance")
	if GetBool("savegame.mod.killstreak50.red") == true then
		SetPostProcessingProperty("colorbalance", 0.7, 0, 0)
	else
		SetPostProcessingProperty("colorbalance", r,g,b)
	end
PlayMusic("MOD/snd/Stained_-Brutal-Calamity.ogg")
end

function GetAimPos()
	local ct = GetCameraTransform()
	local forwardPos = TransformToParentPoint(ct, Vec(0, 0, -100))
    local direction = VecSub(forwardPos, ct.pos)
    local distance = VecLength(direction)
	local direction = VecNormalize(direction)
	local hit, hitDistance = QueryRaycast(ct.pos, direction, distance)
	if hit then
		forwardPos = TransformToParentPoint(ct, Vec(0, 0, -hitDistance))
		distance = hitDistance
	end
	return forwardPos, distance
end

function Slap()
	local forwardPos = TransformToParentPoint(GetCameraTransform(), Vec(0, 0, -1))
	local direction = VecSub(forwardPos, GetCameraTransform().pos)
	QueryRequire("physical")
	local hit, dist, normal, shape = QueryRaycast(GetCameraTransform().pos, direction, 3)
	if hit then
			PlaySound(hitsound, GetPlayerTransform().pos, 2)--, false)
		local body = GetShapeBody(shape)
		if IsBodyDynamic(body) then
			local mass = GetBodyMass(body)
			local scale = mass > 1000 and slappower/1.35 or slappower*3.5
			local vel = VecScale(direction, 0.5)
			vel = VecScale(vel, scale)
			SetBodyVelocity(body, vel)
			MakeHole(direction.pos, damage*1, damage*1, damage*1)
		end
	end
	swingTimer = 0.283
end

function tick(dt)
	if GetString("game.player.tool") == "killstreak50" and GetPlayerVehicle() == 0 then
		if InputPressed("lmb") then
			Slap()
		end

		local b = GetToolBody()
		if b ~= 0 then
			local offset = Transform(Vec(0, 0, 0), QuatEuler(0, 0, 0))
			SetToolTransform(offset)

			if swingTimer > 0 then
				local t = Transform()
				t.pos = Vec(0, 0, -swingTimer*3)
				t.rot = QuatEuler(swingTimer*0, 0, 0)
				SetToolTransform(t)

				swingTimer = swingTimer - dt
			end
		end
	end


function lookpos()
	local t = GetCameraTransform()
	local transform = TransformToParentVec(t, Vec(0, 0, -1))
	hit, dist, normal, shape = QueryRaycast(t.pos, transform, 4)
	if hit then
		local pos = VecAdd(t.pos, VecScale(transform, dist))
		return pos
	else
		return false
	end
end
end